<?php

namespace Drupal\monolog_elasticsearch_date_processor;

use Monolog\DateTimeImmutable;

/**
 * MonologProcessorElasticsearchDate service for processing this way.
 */
class MonologProcessorElasticsearchDate {

  /**
   * Invoke the logging.
   *
   * @param array $record
   *   The record to be logged.
   *
   * @return array
   *   The record.
   */
  public function __invoke(array $record) {
    if (empty($record["datetime"])) {
      return $record;
    }
    $datetime = $record["datetime"];
    if ($datetime instanceof \DateTime) {
      $record['extra']['elasticsearch_date'] = $datetime->format('Y-m-d\TH:i:s.v\Z');
    }
    if ($datetime instanceof DateTimeImmutable) {
      $record['extra']['elasticsearch_date'] = $datetime->format('Y-m-d\TH:i:s.v\Z');
    }
    return $record;
  }

}
